#!/usr/bin/perl

# The Unveiler v2.0 
# Nick Mossie -- ld@initiated.com
# Jon Mossie -- curve@initiated.com
# Parses the CheaterList.txt file output by popular cheat detectors for 
# Counter-Strike and outputs a webpage.

# You must set this!!
$banned_filename="banned.cfg"; # Rename the file to whatever you wish.
$path_to_cheater_list_file="/home/jon/hlds_l/cstrike/CheaterList.txt";
$url_to_script="http://www.initiated.com/ini/cheaters.html";
# On the following point to a directory other than where your GAME SERVER
# banned.cfg file resides. Typically users use the same location of the script. 
# Leave the $banned_filename text in tact.
$path_to_ban_cfg="/home/www.initiated.com/cgi-bin/inicheaters/$banned_filename";
$url_to_ban_cfg="http://www.initiated.com/cgi-bin/inicheaters/$banned_filename";

# Change the following to your desire.
$max_users_listed="50";
$table_sort="date"; # Use date, wonid, cheat, name.
$table_width="100%";
$table_border="0"; # Set to 0 for no border
$table_border_color="#000000";
$table_cellpadding="4";
$table_cellspacing="1";
$table_font_face="verdana";
$table_font_size="1";
$table_font_color="#000000";
$table_title_bg_color="#666666";
$table_newest_cheater_header_bg_color="#AAAAAA";
$table_cheater_header_bg_color="#AAAAAA";
$table_newest_cheater_bg_color="#CCCCCC";
$table_body_bg_color1="#BBBBBB"; # Light
$table_body_bg_color2="#CCCCCC"; # Dark
$table_ver_bg_color="#333333"; # Version backround color

# No need to edit anything below.

use CGI qw/:standard/;
print header;

if(param('sort')) { $table_sort=param('sort'); }

sub update_sort_text {
   local($sort_text) = @_;
   local($se) = "checked " if($table_sort eq $sort_text);
   $sort_open="\n<input type=radio ${se}name=sort value=\"${sort_text}\">  ";
   $sort_close="\n";
}

sub sortby { 
   local($name, $date, $time, $wonid, $cheat) = split(/\|/, $a); 
   local($name2, $date2, $time2, $wonid2, $cheat2) = split(/\|/, $b); 
   # sort values
   if ($table_sort eq  "date") { return $date <=> $date2; }
   elsif ($table_sort eq "name") { return $name cmp $name2; } 
   elsif ($table_sort eq "wonid") { return $wonid <=> $wonid2; } 
   elsif ($table_sort eq "cheat") { return $cheat cmp $cheat2; }
   else { return $date <=> $date2; }
}

open(cheat, "$path_to_cheater_list_file");
@cheatfile=grep {/detected/} <cheat>;
close cheat;

$counter=0;
$user_counter=1;
$totalcheats = 0;
my %cheathash;

foreach $line (@cheatfile) {
   $date = substr($line, 0, 11) . substr($line, 20, 4);
   $time = substr($line, 11, 8);
   $name = $line;
   $name =~ s/.*?Name: (.*?) from.*/\1/;
   $wonid = $line;
   $wonid =~ s/.*?WONID: (.*?) (detected|listed).*/\1/; 
   $cheat = $line;
   $cheat =~ s/.*?(listed as)* detected (with active|of having|due to cheat) (.*?)\.\W/\3/; 
   $cheat =~ s/.*?from (.*)/\1/;
   $name =~ s/\|/\^/g;
   chomp($wonid); chomp($date); chomp($time); 
   chomp($name); chomp($cheat);
#print "$name|$wonid|$cheat<br>\n";
   if ($wonid =~ /[0-9]+/ && $name !~ /\[i_N_i\]/) {
      if ($lastwonid ne $wonid) {
         push @cheaters, "$name|$date|$time|$wonid|$cheat";
      }
   }
   $lastwonid=$wonid;
}

print "<form action='$url_to_script' method='get' name=myform>";
print "<table cellpadding=$table_cellpadding cellspacing=$table_cellspacing border=$table_border bgcolor=$table_border_color width=$table_width>";
&update_sort_text("wonid");
print "<tr bgcolor=$table_title_bg_color><td><font face=$table_font_face color=$table_font_color>${sort_open}WON${sort_close}</font></td>";
&update_sort_text("name");
print "<td><font face=$table_font_face color=$table_font_color>${sort_open}Player Name${sort_close}</font></td>";
&update_sort_text("cheat");
print "<td><font face=$table_font_face color=$table_font_color>${sort_open}Cheat${sort_close}</font></td></tr>";
print "<tr bgcolor=$table_newest_cheater_header_bg_color><td colspan=3 align=center><font face=$table_font_face color=$table_font_color>Newest Cheater</font></td></tr>";
print "<tr bgcolor=$table_newest_cheater_bg_color><td><font size=$table_font_size face=$table_font_face color=$table_font_color>$wonid</font></td><td><font size=$table_font_size face=$table_font_face color=$table_font_color>$name<br>$date $time</font></td><td><font size=$table_font_size face=$table_font_face color=$table_font_color>$cheat</font></td></tr>\n";
print "<tr bgcolor=$table_cheater_header_bg_color><td colspan=3 align=center><font face=$table_font_face color=$table_font_color>Cheaters</font></td></tr>";
open (ban_cfg, ">$path_to_ban_cfg");
foreach $line (sort sortby @cheaters) {
   ($name, $date, $time, $wonid, $cheat) = split(/\|/, $line);
   if ($cheathash{$cheat}) 
      { $cheathash{$cheat}+=1; } 
   else 
      { $cheathash{$cheat}=1; }
   $totalcheats++;
   if ($counter%2 == 0) { $bgcolor="$table_body_bg_color1"; } else { $bgcolor="$table_body_bg_color2"; }
   if (!$name) { $name = "<i>No Name Specified</i>"; }
   print ban_cfg "banid 0.0 $wonid\n";
   if ((param('listnumber') && $totalcheats >= param('listnumber')) || 
       (!param('listnumber') && $totalcheats <= $max_users_listed)
      ) {
      $display_counter=$user_counter;
      $display_counter=$user_counter+param('listnumber')-1 unless !param('listnumber');
      print "<tr bgcolor=$bgcolor><td><font size=$table_font_size face=$table_font_face color=$table_font_color>$display_counter.  $wonid</font></td><td><font size=$table_font_size face=$table_font_face color=$table_font_color>$name<br>$date $time</font></td><td><font size=$table_font_size face=$table_font_face color=$table_font_color>$cheat</font></td></tr>\n" unless ($user_counter > $max_users_listed);
      $user_counter++;
   }
   $counter++;
   $lastbgcolor=$bgcolor;
}
close(ban_cfg);
$counter=1;
print "<tr bgcolor=$table_title_bg_color><td colspan=3><font face=$table_font_face color=$table_font_color>";
print "<input type=hidden name=listnumber value='1'>";
print "<a href=\"javascript:document.myform.listnumber.value=1; document.myform.submit();\">1</a> | ";
for (1 .. $totalcheats) {
   $counter++;
   if($counter > $max_users_listed) {
      print "<a href=\"javascript:document.myform.listnumber.value=$_; document.myform.submit();\">$_</a>";
      print " | " unless $totalcheats - $_ < $max_users_listed;
      $counter=1;
   }
}
print "</font></center></td></tr>";
print "</table>";
$counter=0;
print "<p><table cellpadding=$table_cellpadding cellspacing=$table_cellspacing border=$table_border bgcolor=$table_border_color width=$table_width>";
print "<tr bgcolor=$table_title_bg_color><td><font face=$table_font_face color=$table_font_color>Cheat Type</font></td><td><font face=$table_font_face color=$table_font_color>Number of Occurances</font></td></tr>";
foreach $key (sort { $cheathash{$b} <=> $cheathash{$a} } keys %cheathash) {
   if ($counter%2 == 0) { $bgcolor="$table_body_bg_color1"; } else { $bgcolor="$table_body_bg_color2"; }
   print "<tr bgcolor=$bgcolor><td><font size=$table_font_size face=$table_font_face color=$table_font_color>$key</font></td><td><font size=$table_font_size face=$table_font_face color=$table_font_color>$cheathash{$key}</font></td></tr>";
   $counter++;
} 
print "<tr bgcolor=$table_title_bg_color><td><font face=$table_font_face color=$table_font_color>Total</font></td><td><font face=$table_font_face color=$table_font_color>$totalcheats</font></td></tr>";
print "<tr bgcolor=$table_title_bg_color><td colspan=2><font face=$table_font_face color=$table_font_color><center><a href=$url_to_ban_cfg>Download $banned_filename</a></font></center></td></tr>";
print "<tr bgcolor=$table_ver_bg_color><td colspan=2><font face=$table_font_face color=$table_font_color><center>Parsed by:<a href=http://www.initiated.com/ini/theunveiler.zip>The Unveiler v3.0</a></font></center></td></tr>";
print "</table>";
print "</form>";
